"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var TypeMongoDBFeatureModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeMongoDBFeatureModule = void 0;
const common_1 = require("@nestjs/common");
const utils_1 = require("./utils");
const type_mongodb_constants_1 = require("./type-mongodb.constants");
let TypeMongoDBFeatureModule = TypeMongoDBFeatureModule_1 = class TypeMongoDBFeatureModule {
    static register(documents, connectionName = type_mongodb_constants_1.TYPE_MONGODB_DEFAULT_CONNECTION) {
        utils_1.Storage.addDocuments(documents, connectionName);
        const providers = this.createDocumentProviders(documents, connectionName);
        return {
            module: TypeMongoDBFeatureModule_1,
            providers,
            exports: providers
        };
    }
    static createDocumentProviders(documents, connectionName = type_mongodb_constants_1.TYPE_MONGODB_DEFAULT_CONNECTION) {
        const providers = [];
        for (const document of documents) {
            providers.push({
                provide: utils_1.getRepositoryToken(document, connectionName),
                useFactory: (dm) => {
                    return dm.getRepository(document);
                },
                inject: [utils_1.getDocumentManagerToken(connectionName)]
            });
        }
        return providers;
    }
};
TypeMongoDBFeatureModule = TypeMongoDBFeatureModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({})
], TypeMongoDBFeatureModule);
exports.TypeMongoDBFeatureModule = TypeMongoDBFeatureModule;
//# sourceMappingURL=type-mongodb-feature.module.js.map