"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Storage = void 0;
class Storage {
    static addDocuments(documents, connectionName) {
        if (!this.documents.has(connectionName)) {
            this.documents.set(connectionName, new Set(documents));
        }
        else {
            documents.forEach((document) => this.documents.get(connectionName).add(document));
        }
    }
    static getDocuments(connectionName) {
        if (!this.documents.has(connectionName)) {
            throw new Error(`Documents for connection "${connectionName}" do not exist`);
        }
        return [...this.documents.get(connectionName)];
    }
    static addDocumentManager(connectionName, dm) {
        if (!this.dms.has(connectionName)) {
            this.dms.set(connectionName, dm);
        }
    }
    static getDocumentManagers() {
        return [...this.dms.values()];
    }
}
exports.Storage = Storage;
Storage.documents = new Map();
Storage.dms = new Map();
//# sourceMappingURL=storage.utils.js.map